
import fizz

# handle tick events from the CTM
def tick(tick,chunks):
    replies = []
    if len(chunks) > 0: # do we have chunks?
        for c in chunks:
            if isinstance(c[4],fizz.Func) and c[4].label == 'f': # is the gist a f named functor?
                r = proc(c[4].terms[0]) # execute the content of the functor
                if len(r)>0: # turn each results into a list that will be understood as a reply
                    for v in r:
                        replies.append([fizz.Func("reply",(c[2])),{"retries":4},[v,c[5],c[7]]])

    return replies

# handle link events from the CTM
def link(tick,chunks):
    return tick(tick,chunks)

# handle beat events from the CTM
def beat(tick):
    pass

# process (and execute) a functor and return the result gist(s)
def proc(func):
    if isinstance(func,fizz.Func):
        if func.label == 'add':
            return [add(func.terms)]
        elif func.label == 'mul':
            return [mul(func.terms)]
        else:
            return []
    else:
        return []

# adds all the value passed in a list/tuple
def add(values):
    r = 0
    for v in values:
        r = r + v
    return r

# multiply all the value passed in a list/tuple
def mul(values):
    r = 1
    for v in values:
        r = r * v
    return r